import tkinter as tk
from tkinter import filedialog, ttk
from CsvRead import CsvRead
from statistic import Statistic
from Grading import Grading
from Graph import Graph
import matplotlib.pyplot as plt
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg
from Student import Student
from Network import Network


class App(tk.Tk):
    def __init__(self):
        super().__init__()
        self.title("exam score calculator")
        self.geometry("1000x555")
        self.filename = ""
        self.student_list = []

        # import file
        self.btn_import_file = ttk.Button(self,text="import file",command=self.import_file)
        self.btn_import_file.pack()
        self.btn_import_file.place(x=10,y=270)
        self.lab_import_file = tk.Label(self, text="Please import file")
        self.lab_import_file.pack()
        self.lab_import_file.place(x=85, y=273)

        # show data in table
        # create window
        frame1 = tk.LabelFrame(self, text="Data")
        frame1.place(x=10, y=0, height=270, width=800)
        # Treeview Widget
        self.tv1 = ttk.Treeview(frame1)
        # set the height and width of the widget to 100% of its container (frame1).
        self.tv1.place(relheight=1, relwidth=1)
        # command means update the yaxis view of the widget
        scrolly = tk.Scrollbar(frame1, orient="vertical",command=self.tv1.yview)
        # command means update the xaxis view of the wid
        scrollx = tk.Scrollbar(frame1, orient="horizontal",command=self.tv1.xview)
        # assign the scrollbars to the Treeview Widget
        scrollx.pack(side="bottom", fill="x")
        self.tv1.configure(xscrollcommand=scrollx.set,yscrollcommand=scrolly.set)
        scrolly.pack(side="right", fill="y")

        # search button
        frame2 = tk.LabelFrame(self)
        frame2.place(x=815, y=8, height=540, width=180)
        lab_search = tk.Label(self, text="Search")
        lab_search.place(x=817,y=10)
        search = tk.Entry(self)
        search.place(x=820, y=30)

        # search option
        self.column_var = tk.StringVar()
        self.column_var.set("Search by")
        self.opt_search = ttk.OptionMenu(self,self.column_var)
        self.opt_search.place(x=820, y=50, width=125)
        btn_search = tk.Button(self, text="enter", command=lambda :self.searching(self.column_var.get(),search.get()))
        btn_search.pack()
        btn_search.place(x=945, y=29, height=20, width=40)

        # sort option
        lab_sort = tk.Label(self, text="Sort Data")
        lab_sort.pack()
        lab_sort.place(x=820,y=75)
        self.sort_var = tk.StringVar()
        self.sort_var.set("Sort by")
        self.opt_sort = ttk.OptionMenu(self,self.sort_var)
        self.opt_sort.place(x=820, y=95, width=125)
        btn_sort = tk.Button(self, text="Sort",command=lambda :self.sorting(self.sort_var.get()))
        btn_sort.pack()
        btn_sort.place(x=945, y=95, height=22,width=40)

        # grading
        frame3 = tk.LabelFrame(self, text="Grading")
        frame3.place(x=820,y=120,height=268,width=170)
        # grading type
        lab_grade = tk.Label(self,text= "Grading type")
        lab_grade.pack()
        lab_grade.place(x=825, y=140, height=22)
        self.grade_type = tk.StringVar()
        self.grade_type.set("Grade Type")
        self.opt_grade = ttk.OptionMenu(self,self.grade_type)
        menu = self.opt_grade["menu"]
        menu.add_command(label="Absolute grading", command=lambda v="Absolute grading": self.grade_type.set(v))
        menu.add_command(label="Relative grading", command=lambda v="Relative grading": self.grade_type.set(v))
        self.opt_grade.place(x=825, y=160, width=160)
        # choose subject
        self.lab_subject = tk.Label(text="Subject")
        self.lab_subject.pack()
        self.lab_subject.place(x=825, y=180)
        self.subject = tk.StringVar()
        self.subject.set("Choose Subject")
        self.opt_subject = ttk.OptionMenu(self,self.subject)
        self.opt_subject.place(x=825, y=200, width=160)
        # grading botton
        btn_grade = ttk.Button(self, text="Calculate grade", command=lambda: self.grade_Setting_window(self.subject.get(), self.grade_type.get()))

        btn_grade.pack()
        btn_grade.place(x=825, y=225, width=160)

        frame4 = tk.LabelFrame(self,text="Statistic")
        frame4.place(x=825, y=255, height=125, width=160)
        # statistic label
        self.average = tk.Label(text="Average : ")
        self.sd = tk.Label(text="S.D. : ")
        self.min = tk.Label(text="Min : ")
        self.max = tk.Label(text="Max : ")
        self.total = tk.Label(text="Total : ")
        self.average.pack()
        self.sd.pack()
        self.min.pack()
        self.max.pack()
        self.total.pack()
        self.average.place(x=830, y=275)
        self.sd.place(x=830, y=295)
        self.min.place(x=830, y=315)
        self.max.place(x=830, y=335)
        self.total.place(x=830, y=355)

        frame6 = tk.LabelFrame(self, text="Student analysis")
        frame6.place(x=820, y=390, height=150, width=170)
        chk_set_graph = ttk.Button(self, text="Analysis",command=self.analyze_window)
        chk_set_graph.pack()
        chk_set_graph.place(x=825, y=420, width=160, height=100)

        frame7 = tk.LabelFrame(self)
        frame7.place(x=10,y=297,height=250, width=800)

        self.graph_frame = tk.LabelFrame(self)
        self.graph_frame.pack()
        self.graph_frame.place(x=20,y=310,height=230, width=300)


        self.graph_frame1 = tk.LabelFrame(self)
        self.graph_frame1.place(x=500, y=310, height=230, width=300)

        frame8 = tk.LabelFrame(self, text="Graph setting")
        frame8.place(x=330, y=303, height=238, width=165)

        # graph type
        lab_graph1 = tk.Label(text="Graph1 type")
        lab_graph1.pack()
        lab_graph1.place(x=340,y=325)
        self.graph_type = tk.StringVar()
        self.graph_type.set("Graph type")
        self.opt_graph_type = ttk.OptionMenu(self, self.graph_type)
        self.opt_graph_type.place(x=340, y=350, width=145)
        graph_type_list = ["Histogram", "Bar graph", "Line graph", "Scatter plot"]
        self.update_menuoption(self.opt_graph_type, self.graph_type, "Graph Type", graph_type_list)
        btn_graph = ttk.Button(self, text="Show graph1",command=lambda :self.show_graph(self.canvas,self.ax,self.graph_type.get()))
        btn_graph.pack()
        btn_graph.place(x=340, y=375, width=145)

        # graph type2
        lab_graph2 = tk.Label(text="Graph2 type")
        lab_graph2.pack()
        lab_graph2.place(x=340, y=400)
        self.subject_g = tk.StringVar()
        self.graph_type2 = tk.StringVar()
        self.graph_type2.set("Graph Type")
        self.opt_graph_type2 = ttk.OptionMenu(self, self.graph_type2)
        self.opt_graph_type2.place(x=340, y=425, width=145)
        self.update_menuoption(self.opt_graph_type2, self.graph_type2, "Graph Type", graph_type_list)
        btn_graph = ttk.Button(self, text="Show graph2",command=lambda :self.show_graph(self.canvas1,self.ax1,self.graph_type2.get()))
        btn_graph.pack()
        btn_graph.place(x=340, y=450, width=145)


    def import_file(self):
        self.filename = filedialog.askopenfilename(initialdir="/",title="Select a File",filetypes=(("csv files","*.csv*"),("all files","*.*")))
        self.lab_import_file.configure(text="file: "+self.filename)
        if self.filename:
            self.read = CsvRead(self.filename)
            # update sum all score
            self.read.getSubjectName()
            self.read.addSumData()
            self.read.getSubjectName()

            # show new data
            if self.filename != "":
                cols = list(self.read.df.columns)
                rows = self.read.df.to_numpy().tolist()
                self.update_tabel(cols,rows)
                column = self.read.df.columns.tolist()
                # update after imported file
                # update memu option
                self.update_menuoption(self.opt_search,self.column_var,"Search by",column)
                self.update_menuoption(self.opt_sort,self.sort_var,"Sort by",column)
                subject = []
                for i in self.read.subjectName:
                    subject.append(i)
                subject.append("All Subject")
                self.update_menuoption(self.opt_subject,self.subject,"Choose Subject",subject)


                # update statistic
                self.update_statistic(self.read.df,"total score")
                # print(self.column_var.get())

                # default grade
                g = [80,75,70,65,60,55,50]
                self.fullscorelist = [300]
                self.gradenum = g
                self.grading = Grading(self.read.df,"total score",g)
                self.grading.tscore_cal(self.statistic.average,self.statistic.sd)
                self.grading.grade_cal("Absolute grading", 300)
                self.read.df['grade'] = self.grading.grade
                cols = list(self.read.df.columns)
                rows = self.read.df.to_numpy().tolist()
                self.update_tabel(cols,rows)

                # initailize graph object
                self.graph = Graph(self.read.df)


                # defalt graph1
                y = self.graph.setGradefrequency("grade")
                fig,self.ax = plt.subplots()
                self.ax.bar(self.graph.grade, y)
                self.ax.set_title("Overall grade bar graph")
                for item in ([self.ax.title, self.ax.xaxis.label, self.ax.yaxis.label] + self.ax.get_xticklabels() + self.ax.get_yticklabels()):
                    item.set_fontsize(7)
                # create canvas
                self.canvas = FigureCanvasTkAgg(fig, master=self.graph_frame)
                self.canvas.draw()
                self.canvas.get_tk_widget().pack(side=tk.TOP, fill=tk.BOTH, expand=1)


                # defalt graph2
                xlist =self.read.df['total score'].tolist()
                fig1, self.ax1 = plt.subplots()
                self.ax1.hist(xlist, bins=10)
                self.ax1.set_title("histogram of total grade")
                self.ax1.set_xlabel("score")
                self.ax1.set_ylabel("frequency")
                self.ax1.set_xticks([50,100,150,200,250,300])
                for item in ([self.ax1.title, self.ax1.xaxis.label, self.ax1.yaxis.label] + self.ax1.get_xticklabels() + self.ax1.get_yticklabels()):
                    item.set_fontsize(7)
                # create canvas
                self.canvas1 = FigureCanvasTkAgg(fig1, master=self.graph_frame1)
                self.canvas1.draw()
                self.canvas1.get_tk_widget().pack(side=tk.TOP, fill=tk.BOTH, expand=1)

                # initailize Student

                for i in range(self.read.df.shape[0]):
                    s_list = []
                    s_list.append(self.read.df["total score"][i])
                    s_list.append(self.read.df["grade"][i])
                    self.student = Student(self.read.df["ID"][i], self.read.df["Name"][i], s_list)
                    self.student_list.append(self.student)


    def analyze_window(self):
        new_window = tk.Toplevel(self)
        new_window.title("network setting")
        new_window.geometry("350x120")
        label1 = tk.Label(new_window, text="Analyzing what group of selected student should be in with")
        label1.pack()
        label1.place(x=10, y=10)
        label11 = tk.Label(new_window, text="depend on similarity of each student")
        label11.pack()
        label11.place(x=10, y=30)
        label2 = tk.Label(new_window, text="Selected student's ID")
        label2.pack()
        label2.place(x=10, y=50)
        id = tk.Entry(new_window)
        id.place(x=130, y=50,width=150)
        label3 = tk.Label(new_window, text="Number of student in group")
        label3.pack()
        label3.place(x=10, y=70)
        num = tk.Entry(new_window)
        num.place(x=170,y=70,width=150)
        btn = ttk.Button(new_window,text="Generate",command=lambda : self.network_show(int(id.get()),int(num.get())))
        btn.place(x=10,y=90)

    def network_show(self,id,n):
        network = Network(self.student_list, id, n)
        new_window = tk.Toplevel(self)
        new_window.title("network setting")
        new_window.geometry("300x100")
        label1 = tk.Label(new_window, text="the group that selected student should be in is")
        label1.pack()
        label1.place(x=10, y=10)
        a = network.analize_group()
        label2 = tk.Label(new_window, text=a)
        label2.pack()
        label2.place(x=10, y=30)
        network.visaulize()


    def update_tabel(self,column,rows):
        # delete old file
        self.tv1.delete(*self.tv1.get_children())

        self.tv1['column'] = list(column)
        self.tv1['show'] = "headings"
        for column in self.tv1["column"]:
            self.tv1.heading(column, text=column)
            self.tv1.column(column, width=50)
        for row in rows:
            self.tv1.insert("", "end", values=row)


    def update_menuoption(self,menuopt,var,text,column):
        var.set(text)
        menu = menuopt['menu']
        menu.delete(0, 'end') # remove existing menu option
        # add menu
        for c in column:
            menu.add_command(label=c, command=lambda v=c: var.set(v))

    def update_statistic(self,df,data):
        self.statistic = Statistic(df,data)
        # avg
        self.statistic.cal_average()
        self.average.configure(text=f"Average : {self.statistic.average:.2f}")
        # sd
        self.statistic.cal_sd()
        self.sd.configure(text=f"S.D. : {self.statistic.sd:.2f}")
        # min
        self.statistic.cal_min()
        self.min.configure(text=f"Min : {self.statistic.min}")
        # max
        self.statistic.cal_max()
        self.max.configure(text=f"Max : {self.statistic.max}")
        # total
        self.statistic.cal_total()
        self.total.configure(text=f"Total : {self.statistic.total}")

    def searching(self,data,value):
        try:
            if self.filename != "":
                if data == "Name":
                    search_df = self.read.df.loc[self.read.df[data] == value]
                else:
                    search_df = self.read.df.loc[self.read.df[data] == int(value)]
                cols = list(search_df.columns)
                rows = search_df.to_numpy().tolist()
                self.update_tabel(cols,rows)
        except ValueError:
            new_window = tk.Toplevel(self)
            new_window.title("Value error")
            label = tk.Label(new_window, text="Please type again")
            label.pack()
            button = tk.Button(new_window, text="Close", command=new_window.destroy)
            button.pack()

    def sorting(self,data):
        if self.filename != "":
            sort_df = self.read.df.sort_values(by=data)
            cols = sort_df.columns
            rows = sort_df.to_numpy().tolist()
            self.update_tabel(cols,rows)


    def grade_Setting_window(self,s,type):
        # create window
        new_window = tk.Toplevel(self)
        new_window.title("grading setting")
        new_window.geometry("180x300")
        label1 = tk.Label(new_window, text="Score percent requirement")
        label1.pack()
        label1.place(x=10, y=10)
        a_lab = tk.Label(new_window, text="A :")
        a_lab.pack()
        a_lab.place(x=10, y=30)
        a = tk.Entry(new_window)
        a.place(x=35, y=30)
        bp_lab = tk.Label(new_window, text="B+:")
        bp_lab.pack()
        bp_lab.place(x=10, y=50)
        bp = tk.Entry(new_window)
        bp.place(x=35, y=50)
        b_lab = tk.Label(new_window, text="B :")
        b_lab.pack()
        b_lab.place(x=10, y=70)
        b = tk.Entry(new_window)
        b.place(x=35, y=70)
        cp_lab = tk.Label(new_window, text="C+:")
        cp_lab.pack()
        cp_lab.place(x=10, y=90)
        cp = tk.Entry(new_window)
        cp.place(x=35, y=90)
        c_lab = tk.Label(new_window, text="C:")
        c_lab.pack()
        c_lab.place(x=10, y=110)
        c = tk.Entry(new_window)
        c.place(x=35, y=110)
        dp_lab = tk.Label(new_window, text="D+:")
        dp_lab.pack()
        dp_lab.place(x=10, y=130)
        dp = tk.Entry(new_window)
        dp.place(x=35, y=130)
        d_lab = tk.Label(new_window, text="D:")
        d_lab.pack()
        d_lab.place(x=10, y=150)
        d = tk.Entry(new_window)
        d.place(x=35, y=150)
        label2 = tk.Label(new_window,text="Full score")
        label2.pack()
        label2.place(x=10, y=170)

        if s == "All Subject":
            sub = ""
            for i in self.read.subjectName:
                sub = sub+" "+i
            text = "(put in list ex: 100,100,100,300) :"
            label3 = tk.Label(new_window, text=sub)
            label3.pack()
            label3.place(x=5, y=190)
            label4 = tk.Label(new_window, text=text)
            label4.pack()
            label4.place(x=5, y=210)
            fs = tk.Entry(new_window)
            fs.place(x=10, y=230, width=150)
            def_fs = '100,100,100,300'
        else:
            label3 = tk.Label(new_window,text=s+ " :")
            label3.pack()
            label3.place(x=10, y= 190)
            fs = tk.Entry(new_window)
            fs.place(x=95,y= 190,width=80)
            def_fs = 100
            if s == "total score":
                def_fs = 300

        ok_button = tk.Button(new_window, text="ok", command=lambda:self.show_grade(s,type,a.get(), bp.get(), b.get(), cp.get(), c.get(), dp.get(), d.get(),fs.get()))
        ok_button.pack()
        ok_button.place(x=40,y=250)

        def_button = tk.Button(new_window, text="default setting",
                              command=lambda: self.show_grade(s, type, 80, 75, 70, 65, 60,
                                                              55, 55, def_fs))
        def_button.pack()
        def_button.place(x=70, y=250)

    def show_grade(self,s,type,a, bp, b, cp, c, dp, d,fullscore):
        g = [float(a), float(bp), float(b), float(cp), float(c), float(dp), float(d)]
        self.gradenum = g
        if s == "All Subject":
            s = self.read.subjectName
            n=0
            list_fs = [int(num) for num in fullscore.split(",")]
            self.fullscorelist = list_fs
            for i in self.read.df.columns:
                if "grade" in i:
                    self.read.df.pop(i)
            for i in s:
                grading = Grading(self.read.df, i, g)
                self.statistic.data = i
                self.statistic.cal_average()
                self.statistic.cal_sd()
                grading.tscore_cal(self.statistic.average, self.statistic.sd)
                grading.grade_cal(type,int(list_fs[n]))
                self.read.df[i+' grade'] = grading.grade
                grading.grade = []
                n = n+1


        else:
            self.update_statistic(self.read.df, s)
            grading = Grading(self.read.df, s, g)
            grading.tscore_cal(self.statistic.average, self.statistic.sd)
            grading.grade_cal(type,int(fullscore))
            for i in self.read.df.columns:
                if "grade" in i:
                    self.read.df.pop(i)
            self.read.df[s+' grade'] = grading.grade
        cols = list(self.read.df.columns)
        rows = self.read.df.to_numpy().tolist()
        self.update_tabel(cols, rows)

    def show_graph(self,cv,ax,type):
        if type == "Bar graph":
            self.bargraph_window(cv,ax)
        elif type == "Line graph":
            self.linegraph_window(cv,ax)
        elif type == "Histogram":
            self.hist_window(cv,ax)
        elif type == "Scatter plot":
            self.scatter_window(cv,ax)


    def bargraph_window(self,cv,ax):
        new_window = tk.Toplevel(self)
        new_window.title("graph setting")
        new_window.geometry("180x250")
        setg_lab = tk.Label(new_window,text="Set graph")
        setg_lab.pack()
        setg_lab.place(x=10, y=10)
        setx_lab = tk.Label(new_window, text="x: graph")
        setx_lab.pack()
        setx_lab.place(x=10, y=30)
        x_var = []
        n = 0
        canvas = tk.Canvas(new_window, width=200, height=200)
        canvas.pack()
        canvas.place(x=0, y=50)
        for i in self.read.getGradelist():
            var = tk.StringVar()
            x_var.append(var)
            chk_set_name = ttk.Checkbutton(new_window, text=i, variable=var)
            chk_set_name.pack()
            chk_set_name.place(x=10, y=50 + n)
            n = n + 20

        btn = ttk.Button(new_window, text="Generate graph",command=lambda : self.graph.bargraph(ax,cv,x_var,self.read.getGradelist()))
        btn.pack()
        btn.place(x=10, y=50+n, width=150)


    def linegraph_window(self,cv,ax):
        new_window = tk.Toplevel(self)
        new_window.title("graph setting")
        new_window.geometry("180x250")
        setg_lab = tk.Label(new_window, text="Set graph")
        setg_lab.pack()
        setg_lab.place(x=10, y=10)
        varlist = ["Choose value", "grade", "subject"]
        selected_option = tk.StringVar(value=varlist[0])

        def option_menu_callback(*args):
            x_var = []
            n = 0
            if selected_option.get() == "grade":
                canvas = tk.Canvas(new_window, width=200, height=200)
                canvas.pack()
                canvas.place(x=0, y=50)
                for i in self.read.getGradelist():
                    var = tk.StringVar()
                    x_var.append(var)
                    chk_set_name = ttk.Checkbutton(new_window, text=i, variable=var)
                    chk_set_name.pack()
                    chk_set_name.place(x=10, y=50 + n)
                    n = n + 20
                collist = self.read.getGradelist()
            elif selected_option.get() == "subject":
                canvas = tk.Canvas(new_window, width=200, height=200)
                canvas.pack()
                canvas.place(x=0, y=50)
                for i in self.read.subjectName:
                    var = tk.StringVar()
                    x_var.append(var)
                    chk_set_name = ttk.Checkbutton(new_window, text=i, variable=var)
                    chk_set_name.pack()
                    chk_set_name.place(x=10, y=50 + n)
                    n = n + 20
                collist = self.read.subjectName
            btn = ttk.Button(new_window, text="Generate graph",
                             command=lambda: self.graph.linegraph(ax, cv, x_var, collist,selected_option.get()))
            btn.pack()
            btn.place(x=10, y=50 + n, width=150)

        opt1 = ttk.OptionMenu(new_window, selected_option, *varlist, command=option_menu_callback)
        opt1.pack()
        opt1.place(x=10, y=30, width=150)

    def hist_window(self,cv,ax):
        new_window = tk.Toplevel(self)
        new_window.title("graph setting")
        new_window.geometry("180x250")
        setg_lab = tk.Label(new_window, text="Set graph")
        setg_lab.pack()
        setg_lab.place(x=10, y=10)

        varlist = ["Choose value", "grade", "subject"]
        selected_option = tk.StringVar(value=varlist[0])

        def option_menu_callback(*args):
            x_var = []
            n = 0
            if selected_option.get() == "grade":
                canvas = tk.Canvas(new_window, width=200, height=200)
                canvas.pack()
                canvas.place(x=0, y=50)
                for i in self.read.getGradelist():
                    var = tk.StringVar()
                    x_var.append(var)
                    chk_set_name = ttk.Checkbutton(new_window, text=i, variable=var)
                    chk_set_name.pack()
                    chk_set_name.place(x=10, y=50 + n)
                    n = n + 20
                collist = self.read.getGradelist()
            elif selected_option.get() == "subject":
                canvas = tk.Canvas(new_window, width=200, height=200)
                canvas.pack()
                canvas.place(x=0, y=50)
                for i in self.read.subjectName:
                    var = tk.StringVar()
                    x_var.append(var)
                    chk_set_name = ttk.Checkbutton(new_window, text=i, variable=var)
                    chk_set_name.pack()
                    chk_set_name.place(x=10, y=50 + n)
                    n = n + 20
                collist = self.read.subjectName
            btn = ttk.Button(new_window, text="Generate graph",
                             command=lambda: self.graph.histgraph(ax, cv, x_var, collist, selected_option.get(),self.gradenum,self.fullscorelist))
            btn.pack()
            btn.place(x=10, y=50 + n, width=150)

        opt1 = ttk.OptionMenu(new_window, selected_option, *varlist, command=option_menu_callback)
        opt1.pack()
        opt1.place(x=10, y=30, width=150)

    def scatter_window(self,cv,ax):
        new_window = tk.Toplevel(self)
        new_window.title("graph setting")
        new_window.geometry("180x250")
        setg_lab = tk.Label(new_window, text="Set graph")
        setg_lab.pack()
        setg_lab.place(x=10, y=10)
        var_x = tk.StringVar(value="choose x")
        opt_x = ttk.OptionMenu(new_window,var_x)
        opt_x.pack()
        opt_x.place(x=10, y=30, width=150)
        self.update_menuoption(opt_x,var_x,"choose x",self.read.subjectName)
        var_y= tk.StringVar(value="choose y")
        opt_y = ttk.OptionMenu(new_window, var_y)
        opt_y.pack()
        opt_y.place(x=10, y=50, width=150)
        self.update_menuoption(opt_y, var_y, "choose y", self.read.subjectName)

        btn = ttk.Button(new_window, text="Generate graph",
                         command=lambda: self.graph.scattergraph(ax, cv, var_x.get(),var_y.get()))
        btn.pack()
        btn.place(x=10, y=70, width=150)

    def run(self):
        self.mainloop()