import matplotlib.pyplot as plt
import networkx as nx
class Network:
    def __init__(self,students,target,groupsize):
        self.__Studentlist = students
        self.G = nx.Graph()
        self.targetindex = target-1
        self.group_size =groupsize

    def add_vertex(self):
        id = []
        for i in range(len(self.__Studentlist)):
            for j in range(i, len(self.__Studentlist)):
                if self.__Studentlist[self.targetindex].scoreList[1] == self.__Studentlist[j].scoreList[1]:
                    id.append(self.__Studentlist[j].id)
        self.G.add_nodes_from(id)
        # print(id)

    def add_edges(self):
        for i in range(len(self.__Studentlist)):
            for j in range(i+1,len(self.__Studentlist)):
                if self.__Studentlist[self.targetindex].scoreList[1] == self.__Studentlist[j].scoreList[1]:
                    if j != self.targetindex:
                        self.G.add_edge(self.__Studentlist[self.targetindex].id, self.__Studentlist[j].id, weight=abs(self.__Studentlist[self.targetindex].scoreList[0] - self.__Studentlist[j].scoreList[0]))


    def visaulize(self):
        self.add_edges()
        self.add_vertex()
        plt.figure()
        nx.draw(self.G, with_labels=True)
        plt.title("Network Graph")
        plt.axis("off")
        plt.show()

    def analize_group(self):
        self.add_edges()
        self.add_vertex()
        # Find Shortest Distances
        shortest_distances = nx.shortest_path_length(self.G, self.targetindex+1, weight="weight", method='dijkstra')
        groups = []
        sorted_distances = sorted(shortest_distances.items(), key=lambda x: x[1])  # Sort distances
        for student, distance in sorted_distances:
            if len(groups) < self.group_size:
                groups.append(student)
            if len(groups) == self.group_size:
                break
        return groups




